<?php
namespace WebService\Controller;

use Cake\Mailer\MailerAwareTrait;
use Cake\Network\Exception\UnauthorizedException;
use Cake\Utility\Security;
use CakeDC\Users\Controller\Traits\CustomUsersTableTrait;
use CakeDC\Users\Controller\Traits\PasswordManagementTrait;
use CakeDC\Users\Controller\Traits\ProfileTrait;
use CakeDC\Users\Exception\UserNotFoundException;
use CakeDC\Users\Exception\WrongPasswordException;
use Firebase\JWT\JWT;
use http\Exception;
use WebService\Controller\AppController;

/**
 * Users Controller
 *
 * @property \WebService\Model\Table\UsersTable $Users
 *
 * @method \WebService\Model\Entity\User[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class UsersController extends AppController
{

    use MailerAwareTrait;
    use CustomUsersTableTrait;
    use ProfileTrait;
    use PasswordManagementTrait;

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->loadComponent('Accounts/Auth.Remember');
        $this->loadComponent('Cookie');
        $this->Auth->constructAuthenticate();
    }

    public function login()
    {
        $user = $this->Auth->identify();
        if (!$user) {
            $this->set([
                'error' => true,
                'message' => __d('web_service', 'Invalid username or password, try again'),
                '_serialize' => ['error', 'message'],
            ]);

            return;
        }

        $this->set([
            'error' => false,
            'auth' => $user['id'],
            '_serialize' => ['error', 'auth'],
        ]);
    }

    public function register()
    {
        $user = $this->Users->newEntity();
        if ($this->request->is('post')) {
            $user = $this->Users->patchEntity($user, $this->request->getData());
            $user->role_id = USER_ROLE;
            $user->token = md5(uniqid($user->email, true));

            if ($this->Users->save($user)) {
                $this->getMailer('Accounts/Auth.User')->send('welcome', [$user]);
                $message = __d('web_service', 'Check your email to verify your account');
                $error = false;
            } else {
                $message = __d('web_service', 'The user could not be saved. Please, try again.');
                $error = true;
            }

            $this->set([
                'message' => $message,
                'error' => $error,
                '_serialize' => ['error', 'message']
            ]);
        }
    }

    public function forgotPassword()
    {
        if ($this->request->is('post')) {
            $user = $this->Users->findByEmail($this->request->getData('email'))->toArray();
            if (count($user) > 0) {
                $this->getMailer('Accounts/Auth.User')->send('recoveryPass', [$user]);

                $message = __d('web_service', 'Email for password recovery sent to your inbox');
                $error = false;

            } else {
                $message = __d('web_service', 'No user found with this email');
                $error = true;
            }

            $this->set([
                'message' => $message,
                'error' => $error,
                '_serialize' => ['error', 'message']
            ]);
        }
    }

    public function getUserInfo()
    {
        if ($this->request->is('post')) {

            $user = $this->Users->get($this->request->getData('auth'));
            $email_hash = md5(strtolower(trim($user->email)));
            $user->profile_img = "https://www.gravatar.com/avatar/" . $email_hash . "?s=400";

            $this->set([
                'error' => false,
                'user' => $user,
                '_serialize' => ['error', 'user'],
            ]);
        } else {
            $this->set([
                'error' => true,
                'message' => 'Internal error',
                '_serialize' => ['error', 'message'],
            ]);
        }
    }

    public function changePassword()
    {
        $id = $this->request->getData('auth');
        $user = $this->Users->get($id);

        if ($this->request->is('post')) {
            try {
                $user = $this->Users->patchEntity($user, $this->request->getData(), ['validate' => 'passwordConfirm']);

                $currentUser = $this->Users->get($user->id, [
                    'contain' => []
                ]);

                if (!$user->checkPassword($user->current_password, $currentUser->password)) {
                    $message = __d('Accounts/profile', 'The old password does not match');
                    $this->set([
                        'error' => true,
                        'message' => $message,
                        '_serialize' => ['error', 'message'],
                    ]);
                    return;
                }

                if ($user->getErrors()) {
                    $message = __d('Accounts/profile', 'Password could not be changed');
                    $this->set([
                        'error' => true,
                        'message' => $message,
                        '_serialize' => ['error', 'message'],
                    ]);
                } else {
                    if ($this->Users->save($user)) {
                        $message = __d('Accounts/profile', 'Password has been changed successfully');

                        $this->set([
                            'error' => false,
                            'message' => $message,
                            '_serialize' => ['error', 'message'],
                        ]);
                    } else {
                        $message = __d('Accounts/profile', 'Password could not be changed');
                        $this->set([
                            'error' => true,
                            'message' => $message,
                            '_serialize' => ['error', 'message'],
                        ]);
                    }
                }
            } catch (UserNotFoundException $exception) {
                $message = __d('Accounts/profile', 'User was not found');
                $this->set([
                    'error' => true,
                    'message' => $message,
                    '_serialize' => ['error', 'message'],
                ]);
            } catch (WrongPasswordException $wpe) {
               $message = __d('Accounts/profile', 'The current password does not match');
                $this->set([
                    'error' => true,
                    'message' => $message,
                    '_serialize' => ['error', 'message'],
                ]);
            } catch (Exception $exception) {
                $message = __d('Accounts/profile', 'Password could not be changed');
                $this->set([
                    'error' => true,
                    'message' => $message,
                    '_serialize' => ['error', 'message'],
                ]);
            }
        }
    }
}
